<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/exec/src/main.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('main_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">main.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="main_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;SigGenLib.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno"><a class="line" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934e">   11</a></span>&#160;<span class="keyword">enum class</span> <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934e">ReturnCodes</a> : int</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;      <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564">OK</a> = 0                                        </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68">QuitOnHelp</a> = 1                                </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea636bc5ca1e0ceb3e4c67067618d7ae09">InvalidConfig</a> = 2                             </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea29762b5e39352a9bcc54410794cd22ed">UnexpectedConfigException</a> = 3                 </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea373af888b05b0b5bfa1449b5140462e5">FailedProcessing</a> = 4                          </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea2e45ff89ee088fc180c39b608f318ff1">UnexpectedProcessingException</a> = 5             </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;};</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keywordtype">int</span> main (<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[])</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="comment">// parse configuration from command line</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <a class="code" href="classsiggen_1_1_options.html">siggen::Options</a> options;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordflow">try</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        siggen::ParseConfigResult <span class="keyword">const</span> result = options.<a class="code" href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">ParseCommandLine</a>(argc, argv);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordflow">if</span> (result == siggen::ParseConfigResult::QuitOnHelp)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;            <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68">ReturnCodes::QuitOnHelp</a>);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordflow">catch</span> (std::exception <span class="keyword">const</span> &amp;)</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        std::cerr &lt;&lt; <span class="stringliteral">&quot;Configuration exception caught, terminating.&quot;</span> &lt;&lt; std::endl;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea636bc5ca1e0ceb3e4c67067618d7ae09">ReturnCodes::InvalidConfig</a>);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    }</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">catch</span> (...)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    {</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        std::cerr &lt;&lt; <span class="stringliteral">&quot;Unexpected configuration exception caught, terminating.&quot;</span> &lt;&lt; std::endl;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea29762b5e39352a9bcc54410794cd22ed">ReturnCodes::UnexpectedConfigException</a>);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    }</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    siggen::initLogging(options.<a class="code" href="classsiggen_1_1_options.html#a0d21253deaca59e2f6f15b5cac5c783a">GetLogLevel</a>());</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    LOGSCOPE();</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Configuration parsed successfully.&quot;</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="comment">// start signature generation</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordflow">try</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Constructing signature generator...&quot;</span>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <a class="code" href="classsiggen_1_1_sig_gen.html">siggen::SigGen</a> sigGen(options);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Processing input file &quot;</span> &lt;&lt; options.<a class="code" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">GetInputFileName</a>();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        sigGen.ProcessToFile();</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordflow">catch</span> (std::exception <span class="keyword">const</span> &amp; e)</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    {</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        std::cerr &lt;&lt; <span class="stringliteral">&quot;Exception caught: &quot;</span> &lt;&lt; e.what() &lt;&lt; std::endl;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea373af888b05b0b5bfa1449b5140462e5">ReturnCodes::FailedProcessing</a>);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    }</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordflow">catch</span> (...)</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    {</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        std::cerr &lt;&lt; <span class="stringliteral">&quot;Processing exception caught, terminating.&quot;</span> &lt;&lt; std::endl;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea2e45ff89ee088fc180c39b608f318ff1">ReturnCodes::UnexpectedProcessingException</a>);</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    }</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    LOGMSG(info) &lt;&lt; <span class="stringliteral">&quot;Terminating with success.&quot;</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordflow">return</span> static_cast&lt;int&gt;(<a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564">ReturnCodes::OK</a>);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea636bc5ca1e0ceb3e4c67067618d7ae09"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea636bc5ca1e0ceb3e4c67067618d7ae09">ReturnCodes::InvalidConfig</a></div><div class="ttdoc">command line is not valid</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a0d21253deaca59e2f6f15b5cac5c783a"><div class="ttname"><a href="classsiggen_1_1_options.html#a0d21253deaca59e2f6f15b5cac5c783a">siggen::Options::GetLogLevel</a></div><div class="ttdeci">uint32_t GetLogLevel() const</div><div class="ttdoc">return user specified verbosity</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00043">Options.h:43</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68">ReturnCodes::QuitOnHelp</a></div><div class="ttdoc">help was invoked</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html"><div class="ttname"><a href="classsiggen_1_1_options.html">siggen::Options</a></div><div class="ttdoc">configuration for generation of signatures file</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00020">Options.h:20</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea2e45ff89ee088fc180c39b608f318ff1"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea2e45ff89ee088fc180c39b608f318ff1">ReturnCodes::UnexpectedProcessingException</a></div><div class="ttdoc">processing failed with unexpected error</div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea373af888b05b0b5bfa1449b5140462e5"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea373af888b05b0b5bfa1449b5140462e5">ReturnCodes::FailedProcessing</a></div><div class="ttdoc">processing failed</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a93b4e1f79b1751cd74e8069639709467"><div class="ttname"><a href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">siggen::Options::GetInputFileName</a></div><div class="ttdeci">const std::string &amp; GetInputFileName() const</div><div class="ttdoc">return user specified input file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00033">Options.h:33</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934e"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934e">ReturnCodes</a></div><div class="ttdeci">ReturnCodes</div><div class="ttdoc">possible return codes from executable</div><div class="ttdef"><b>Definition:</b> <a href="main_8cpp_source.html#l00011">main.cpp:11</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea29762b5e39352a9bcc54410794cd22ed"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea29762b5e39352a9bcc54410794cd22ed">ReturnCodes::UnexpectedConfigException</a></div><div class="ttdoc">unexpected configuration error</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_ab4f252a399a19ddfc05a35984859b15d"><div class="ttname"><a href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">siggen::Options::ParseCommandLine</a></div><div class="ttdeci">ParseConfigResult ParseCommandLine(int argc, char *argv[])</div><div class="ttdoc">reads options from command line</div><div class="ttdef"><b>Definition:</b> <a href="_options_8cpp_source.html#l00008">Options.cpp:8</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_sig_gen_html"><div class="ttname"><a href="classsiggen_1_1_sig_gen.html">siggen::SigGen</a></div><div class="ttdoc">generates signature from input file and writes result to output file</div><div class="ttdef"><b>Definition:</b> <a href="_sig_gen_8h_source.html#l00014">SigGen.h:14</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564">ReturnCodes::OK</a></div><div class="ttdoc">success</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_3503f86ebac7e9741312f92017d9530a.html">exec</a></li><li class="navelem"><a class="el" href="dir_d408fef0c30248ad68c3603d46bec951.html">src</a></li><li class="navelem"><a class="el" href="main_8cpp.html">main.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
